# Example configuration file. Conforms with libconfig format.
#

Example = {

  # APP functionality to enable. The default state is disabled (false)
  APP = {
    Watchdog = true;
    RSATx = false;
    RSARx = true;
    RawTx = true;
    TIMRx = true;
    SPATTx = true;
    MAPTx = true;
    OBERx = false;
    CANVState = false;
    TCClient = false;
  };

  RSARx = {
    NotApplicable = 0;
  };

  RSATx = {
    # Transmit period [ms]
    TxInterval  = 500;

    # WSMP parameters
    WSMP = {
      PSID          = 0xE0525341;   # 0xE0'R''S''A'
      Priority      = 2;
      ChannelNumber = 172;
      DataRate      = 12;           # 6MBps
      TxPower       = 24;
      ExpiryTime    = 0;            # Never
    };

    # See RoadSideAlert definition in DSRC_R36_Source.ASN

    # ITIS.ITIScodes: Mandatory, Default=0xC0DA
    TypeEvent   = 6952; # 'look-out-for-workers'

    # SEQUENCE (SIZE(1..8)) OF ITIS.ITIScodes: Optional
    Description = [
                   0x0000,
                   0x0000,
                   0x0000,
                   0x0000,
                   0x0000,
                   0x0000,
                   0x0000,
                   0x0000
                  ];

    # DE_Priority: Optional
    Priority    = 0x00;

    # DE_HeadingSlice: Optional
    Heading     = 0x0006;

    # DE_Extent: Optional
    Extent      = 0x03;

    # DF_FullPositionVector, Optional
    Position    = [
                   0x529DF0D8,  # lon (overides GPS)
                   0xEB31B196   # lat (overides GPS)
                  ];

    # DE_FurtherInfoID, Optional
    FurtherInfo = "50";
  };

  # Periodic transmission of a pre-defined WSMs
  RawTx = (
    # RawTx[0] - TIM (Speed limit)
    {
      TxInterval  = 1000;             # 10..Transmit period [ms]
      WSM = {
        PSID          = 0x8003;       # pEncoded PSID
        Priority      = 6;            # 0..7
        ChannelNumber = 178;          # 172..184
        DataRate      = 12;           # 12 = 6MBps
        TxPower       = 21;           # -10..27 [dBm]
        ExpiryTime    = 0;            # Never [ms]
        Data = [ 0x00, 0x1f, 0x40, 0x00, 0x10, 0x80, 0xb0, 0x9b,
                 0xc5, 0x26, 0xd6, 0x7e, 0x8f, 0xb3, 0x6a, 0x1e,
                 0x00, 0x4f, 0xc2, 0x00, 0x00, 0x1f, 0x40, 0x30,
                 0x00, 0x76, 0x13, 0x78, 0xa3, 0x2f, 0x4f, 0xd1,
                 0xf8, 0x19, 0xc1, 0x45, 0x21, 0xe0, 0x00, 0x02,
                 0x2c, 0x49, 0x83, 0xb4, 0x31, 0x62, 0x48, 0x5e,
                 0x2e, 0x0b, 0x1a, 0x1c, 0xf2, 0x3e, 0x5a, 0x3f,
                 0x77, 0x35, 0xf0, 0x01, 0x85, 0x58, 0x34, 0x61,
                 0x36, 0x84, 0x80 ];
      };
    },
    # RawTx[1] - TIM (Curve Speed warning)
    {
      TxInterval  = 1000;
      WSM = {
        PSID          = 0x8003;
        Priority      = 6;
        ChannelNumber = 178;
        DataRate      = 12;
        TxPower       = 18;
        ExpiryTime    = 0;
        Data = [0x00, 0x1f, 0x7b, 0x70, 0x00, 0x30, 0x39, 0x00, 0x00,
                0x00, 0x00, 0x00, 0x5f, 0x43, 0x53, 0x57, 0x57, 0x47,
                0x4e, 0x9c, 0x1d, 0x2f, 0x5f, 0x97, 0xc6, 0x1d, 0xbc,
                0x36, 0x65, 0x5f, 0x8f, 0x7e, 0xd5, 0xfd, 0x34, 0xed,
                0x0c, 0x0b, 0x24, 0x1a, 0xc8, 0x04, 0x77, 0xbc, 0xd5,
                0xe5, 0x82, 0x14, 0xa1, 0xfe, 0x04, 0xfc, 0x02, 0xc4,
                0x8b, 0xf4, 0x01, 0x04, 0x17, 0x22, 0x29, 0xe1, 0xdb,
                0xc3, 0x66, 0x54, 0x16, 0x2c, 0xa4, 0x1a, 0xc6, 0x49,
                0x17, 0xbc, 0xd2, 0x8a, 0xc2, 0x14, 0xa0, 0xc8, 0x11,
                0x00, 0x20, 0x81, 0x3c, 0xc0, 0x47, 0x5a, 0x19, 0x33,
                0x0a, 0x43, 0x1f, 0x6c, 0x51, 0xaa, 0xe9, 0x22, 0x8f,
                0x58, 0x94, 0x14, 0x8c, 0x37, 0xe8, 0x86, 0x01, 0x8d,
                0x4a, 0x80, 0x21, 0x83, 0x11, 0x91, 0x10, 0x8d, 0x65,
                0xf1, 0x87, 0x6f, 0x0d, 0x99, 0x57, 0x63, 0xdf, 0xb4 ];
      };
    }
  ); # end of RawTx = (..)

  // Dummy CSW (Curve Speed Warning)
  TIMRx = {
    NotApplicable = 0;
  };

  SPAT =  {
    Enabled = true;
    DynamicPhases = false;    # When set, SPAT phases keeps changing each Tx
    ApplInterval = 100;
    IntersectionId = 0x5566; # RSU intersection ID. This ID should match
                             # IntersectionId of SPAT message to consider
    # Reload time period for difference signal phases - that is only used in
    # case of SPAT message transmission is dynamic (see DynamicPhases above)
    RedPhasePeriod = 260;    # Red state period (tength of sec)
    GreenPhasePeriod = 100;  # Green state period (tength of sec)
    YellowPhasePeriod = 30;  # Yellow state period (tength of sec)
    Movements =
    (
      # TimeToChange: Initial time to change of current phase (tenths of sec)
      #
      # CurrentState: Initial current signal color/state, where:
      #   0 = unavailable---------------------(OFF)
      #   1 = dark----------------------------(OFF)
      #   2 = stop_Then_Proceed---------------(RED)
      #   3 = stop_And_Remain-----------------(RED)
      #   4 = pre_Movement--------------------(maybe RED?)
      #   5 = permissive_Movement_Allowed-----(GREEN)
      #   6 = protected_Movement_Allowed------(GREEN)
      #   7 = permissive_clearance------------(YELLOW)
      #   8 = protected_clearance-------------(YELLOW)
      #   9 = caution_Conflicting_Traffic-----(maybe YELLOW?)
      #
      # Note: state and time are keeping changing by RSU logic, the values
      # below presenting the starting state/time for defined groups
      {
        SignalGroup  = 1, CurrentState = 3, TimeToChange = 130,
        SpeedAdvice =
        (
          # Speed units 0.1 metres/second
          # Distance unit metres
          # Type  0 = None, 1 = greenwave, 2 = ecoDrive, 3 = transit
          {Speed=0,   Distance=30,  Type=2},
          {Speed=56,  Distance=50,  Type=2},
          {Speed=111, Distance=100, Type=2}
        )
      },
      {
        SignalGroup = 2, CurrentState = 3, TimeToChange = 130,
        SpeedAdvice =
        (
          {Speed=0,   Distance=20,  Type=2},
          {Speed=83,  Distance=40,  Type=2},
          {Speed=139, Distance=200, Type=2}
        )
      },
      {
        SignalGroup = 3, CurrentState = 6, TimeToChange = 100,
        SpeedAdvice =
        (
          {Speed=0,  Distance=10,  Type=2},
          {Speed=34, Distance=60,  Type=2},
          {Speed=38, Distance=210, Type=2}
        )
      },
      {
        SignalGroup = 4, CurrentState = 6, TimeToChange = 100,
        SpeedAdvice =
        (
          {Speed=0,   Distance=15,  Type=2},
          {Speed=10,  Distance=25,  Type=2},
          {Speed=153, Distance=95,  Type=2}
        )
      },
      {
        SignalGroup = 5, CurrentState = 6, TimeToChange = 100
        SpeedAdvice =
        (
          {Speed=0,  Distance=28,  Type=2},
          {Speed=28, Distance=55,  Type=2},
          {Speed=69, Distance=150, Type=2}
        )
      },
      {
        SignalGroup = 6, CurrentState = 3, TimeToChange = 260
        SpeedAdvice =
        (
          {Speed=0,   Distance=27,  Type=2},
          {Speed=167, Distance=49,  Type=2},
          {Speed=222, Distance=180, Type=2}
        )
      }
    )
  };
  MAP =  {
    Enabled = true;
    ApplInterval = 1000;
    IntersectionId = 0x5566; # RSU intersection ID. This ID should match
                             # IntersectionId of SPAT message to consider
    Latitude = 498557400;    # RSU latitude in tenths of microdegrees
    Longitude = 85880335;    # RSU longitude in tenths of microdegrees
    Lanes =
    (
      {
        LaneId = 1,
        Nodes =
        (
          # X and Y (cm) for each node are caluclated from end of last node
          {X = 2025, Y = -915},
          {X = 5215, Y = -5545}
        ),
        Connections =
        (
          # SignalGroup: Group that connection belongs to
          # ConnectsTo: Lane ID that lane connects to (should be valid)
          # Maneuver: between this lane and the one it connects to, where:
          #   0 = Undefined
          #   1 = Straight
          #   2 = Left
          #   3 = Right
          {SignalGroup = 1, ConnectsTo = 2, Maneuver = 3},
          {SignalGroup = 2, ConnectsTo = 3, Maneuver = 2}
        )
      },
      {
        LaneId = 2,
        Nodes =
        (
          # X and Y (cm) for each node are caluclated from end of last node
          {X = -1250, Y = -1000},
          {X = -7420, Y = -5815}
        ),
        Connections =
        (
          # SignalGroup: Group that connection belongs to
          # ConnectsTo: Lane ID that lane connects to (should be valid)
          # Maneuver: between this lane and the one it connects to, where:
          #   0 = Undefined
          #   1 = Straight
          #   2 = Left
          #   3 = Right
          {SignalGroup = 3, ConnectsTo = 4, Maneuver = 3},
          {SignalGroup = 4, ConnectsTo = 2, Maneuver = 1}
        )
      },
      {
        LaneId = 3,
        Nodes =
        (
          # X and Y (cm) for each node are caluclated from end of last node
          {X = 1330, Y = 1540},
          {X = 5275, Y = 4295}
        ),
        Connections =
        (
          # SignalGroup: Group that connection belongs to
          # ConnectsTo: Lane ID that lane connects to (should be valid)
          # Maneuver: between this lane and the one it connects to, where:
          #   0 = Undefined
          #   1 = Straight
          #   2 = Left
          #   3 = Right
          {SignalGroup = 5, ConnectsTo = 3, Maneuver = 1},
          {SignalGroup = 6, ConnectsTo = 4, Maneuver = 2}
        )
      }
    )
  };
};
